<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side ref="treeSide" :dataLoading="treeLoading" :default-expand-all="false" :defaultProps="defaultProps"
                   :tabList="['组织路段树']" :treeData="treeData" isDeselect @currentChange="currentChange"></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <div class="search-box-combination">
              <SearchCommon :optionList="optionList" @search="handleSearch" />
            </div>
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button :disabled="isAddDisabled" class="btn btn-plus" icon="el-icon-plus" size="small"
                           type="primary" @click="changePage('EditAddPage', { catalogId: treeItem.id })">
                  添加
                </el-button>
                <el-button :disabled="!currentDataDel.length" :loading="btnLoading" class="btn btn-delete"
                           icon="el-icon-delete" plain size="small" type="danger" @click="handleDelete()">
                  删除
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table ref="multipleSelection" v-loading="tableLoading" :data="tableData"
                          :default-sort="getSorterDirection(params, true)" :max-height="tableMaxHeight" border
                          class="table-list" element-loading-background="rgba(10 ,38 ,61, 0.9)" row-key="id" stripe
                          @select="handleSelection" @selection-change="handleSelectionChange" @sort-change="sortChange"
                          @row-dblclick="handleDbClick">
                  <el-table-column align="center" type="selection" width="70" />
                  <el-table-column :index="index => index + 1 + (params.pageBean.page - 1) * params.pageBean.pageSize"
                                   align="center" label="序号" type="index" width="70" />
                  <el-table-column :formatter="({ roadName }) => roadName || '-'" align="center" label="所属路段"
                                   min-width="80" prop="roadName" show-overflow-tooltip />
                  <!--                  <el-table-column align="center" label="所属路段" min-width="80" prop="roadName"-->
                  <!--                                   show-overflow-tooltip />-->
                  <el-table-column :formatter="({ name }) => name || '-'" align="center" label="巡查队伍"
                                   min-width="120"
                                   prop="account" show-overflow-tooltip />
                  <el-table-column :formatter="({ type }) => dictionaryEscape('dwlx', type) || '-'" align="center"
                                   label="队伍类型" min-width="80" prop="tel" show-overflow-tooltip />

                  <el-table-column :formatter="({ man }) => man || '-'" align="center" label="负责人" min-width="80"
                                   prop="man" show-overflow-tooltip />
                  <el-table-column :formatter="({ tel }) => tel || '-'" align="center" label="负责人联系电话"
                                   min-width="80"
                                   prop="type" show-overflow-tooltip />
                  <el-table-column align="center" label="操作" min-width="100" show-overflow-tooltip>
                    <template v-slot="{ row }">
                      <el-link :underline="false" type="primary" @click="toPersonMgmt(row)">
                        人员管理
                      </el-link>
                      <el-link :underline="false" type="primary" @click="handleDetailPage(row)">
                        详情
                      </el-link>
                      <el-link :disabled="btnLoading" :underline="false" type="danger" @click="handleDelete(row)">
                        删除
                      </el-link>
                    </template>
                  </el-table-column>
                </el-table>
                <pagination ref="paginationPanel" :pageResult="params.pageBean" style="margin-top: 10px"
                            @size-change="handleSizeChange" @current-change="handleCurrentChange" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import {getSorterDirection, refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import treeSide from '@/components/treeSide/index.vue'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {tableData, tableDelete} from '@/api/patrolAndRescue/infoMgmtPatrolsRescues/patrolAndRescueTeamsMgmt'
import PubSub from 'pubsub-js'
import {dictionaryEscape} from '@/utils/dictionary'
import {getTree} from '@/api/tree'


export default {
  name: 'TablePage',
  components: {
    pagination,
    treeSide,
    SearchCommon
  },
  mixins: [TableMixin],
  data() {
    return {
      isAddDisabled: true, // 新增按钮是否禁用
      pubSub: null,
      tableMaxHeight: '600px',
      tableLoading: true,
      treeLoading: true,
      btnLoading: false,
      treeData: [], //左边树
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      tableData: [],//存储表格数据。
      optionList: [
        // {title: '所属路段', prop: ['r.name_'], type: 'input', default: true},
        {title: '巡查队伍', prop: ['t.name_'], type: 'input', default: true}
        // {title: '队伍类型', prop: 't.type_', type: 'select', option: getDictionaryByCode('dwlx'), multiple: false}
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'IN', property: 'roadId'},
          // {operation: 'LIKE', property: 't.ROAD_FULL_ID_', value: ''},
          {group: 'nameRoadName', operation: 'LIKE', relation: 'OR', property: 't.name_'},
          // {group: 'nameRoadName', operation: 'LIKE', relation: 'OR', property: 'r.name_'},
          {operation: 'EQUAL', property: 't.type_', value: '1'}
        ],
        sorter: []
      },
      treeItem: {} // 树形节点选中对象
    }
  },
  created() {
    // 获取树形目录
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id)
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'roadId', array)
      this.loadData()
    })
  },
  //mounted订阅 TablePage 事件，监听新增或编辑操作后的数据刷新
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.handleCurrentChange(1)
          this.params.pageBean.page = 1
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })
  },
  methods: {
    dictionaryEscape,
    getSorterDirection,
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    // 人员管理
    // toPersonMgmt({teamId}) {
    //   this.$router.push({
    //     path: '/platLayout/patrolAndRescue/infoMgmtPatrolsRescues/patrolAndRescuePersonnelMgmt',
    //     query: {
    //       teamId
    //     }
    //   })
    // },
    toPersonMgmt(row) {
      this.$router.push({
        path: '/platLayout/patrolAndRescue/infoMgmtPatrolsRescues/patrolAndRescuePersonnelMgmt',
        query: {
          teamId: row.id
        }
      })
    },

    // 获取公司树
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true
        let {value} = await getTree()
        this.treeData = [value]
      } finally {
        this.treeLoading = false
        callback && callback(this.treeData)
        // this.tableLoading = false
      }
    },
//树形目录转换
    transformTreeData(data) {
      return {
        name: data.name,
        id: data.id,
        children: data.children.reduce((acc, child) => {
          acc.push({
            id: child.id,
            name: child.name,
            path: child.path,
            children: child.roadList.map(road => ({
              id: road.id,
              name: road.name,
              path: road.path
            }))
          })
          return acc
        }, [])
      }
    },

    //左边树节点
    currentChange(nodeItem) {
      console.log(nodeItem, '当前节点')
      if (nodeItem.id === '1766017468444450816') {
        this.isAddDisabled = true
        setQueryValue(this.params, 'roadId ', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isAddDisabled = true
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'roadId ', array)
      } else {
        this.isAddDisabled = false
        setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      }
      // 判断是否是一级目录（有 children 属性）
      // if (nodeItem.children && nodeItem.children.length > 0) {
      //   this.isAddDisabled = true // 禁用新增按钮
      //   const array = nodeItem.children.map(item => item.id)
      //   setQueryValue(this.params, 'roadId ', array)
      //   this.$message.warning('请选择二级目录进行新增操作')
      // } else {
      //   this.isAddDisabled = false // 启用新增按钮
      //   // 修改对应的字段值
      //   setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      // }
      // setQueryValue(this.params, 't.ROAD_FULL_ID_', nodeItem?.id || '')
      this.treeItem = nodeItem || {}
      // console.log(this.treeItem, '/树巡查节点')
      this.calcTableHeight(500)
      // 触发 TreeItemSelected 事件，并传递节点数据
      PubSub.publish('TreeItemSelected', {
          id: nodeItem?.id || '',
          name: nodeItem?.name || '',
          path: nodeItem?.path || ''
        }
      )
      this.params.pageBean.page = 1
      this.loadData()
    },
    //获取数据
    async loadData() {
      this.tableLoading = true
      console.log('查询参数:', this.params) // 打印查询参数
      const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
      this.params.pageBean.total = total
      this.tableData = rows.map(row => ({
        ...row,
        roadName: row.roadName || this.treeItem.name // 如果 row.orgName 为空，使用 treeItem.name
      }))
      this.tableLoading = false
    },

    // 删除
    handleDelete(row) {
      this.clickTimer = true
      setTimeout(_ => this.clickTimer = false)
      this.$confirm('确定删除选中的巡检救援队吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.btnLoading = true
        let ids = row ? row.id : this.currentDataDel.join()
        try {
          const {state} = await tableDelete(ids)
          if (state) {
            this.$message.success(`巡检救援队员删除成功`)
            const {page, pageSize, total} = this.params.pageBean
            const totalPages = Math.ceil(total / pageSize) // 计算总页数
            if (totalPages > 1 && page === totalPages) {
              if (this.tableData.length === 1) { // 当前页只有一条数据
                this.params.pageBean.page -= 1 // 返回前一页
              }
            }
            await this.loadData()
          }
        } finally {
          this.btnLoading = false
        }
      }).catch(_ => _)
    },
    //双击修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      // 确保 row 中包含 orgName
      const payload = {
        ...row,
        roadName: row.roadName || this.treeItem.name // 如果 row.orgName 为空，使用 treeItem.name
      }
      this.changePage('EditAddPage', payload)
    },
    // 改变页面
    changePage(pageName = '', row = {}) {
      if (!pageName) return
      // 传递当前选中的树节点信息
      const payload = row.id ? row : {
        catalogId: this.treeItem.id,
        roadName: this.treeItem.name,
        path: this.treeItem.path,
        clearForm: true // 清空表单标志
      }
      this.$emit('changePage', pageName, _ => {
        PubSub.publish(pageName, payload)
      }, row.id ? '编辑' : '添加')


    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped>
.table-page {
  ::v-deep .left-tree {
    width: 270px !important;
  }

  .basis {
    min-width: 240px !important;
  }
}
</style>
